
void default_algorithm (sp)
  search_ *sp;
{ search_message_ msg;

  set_search_message(&msg, FRESH_START, NULL, NO, cmd.pf.rt, cmd.pf.st);
  sp->approx.achieved = sp->approx.root_approx;
  switch (sp->strategy) {
    case GBB:  gbb_primitive(sp, NULL, &msg); 		break;
    case BFS:  bfs_primitive(sp, NULL, &msg);		break;
    case DFS:  dfs_primitive(sp, NULL, &msg);		break;
    case GDFS: gdfs_primitive(sp, NULL, &msg);		break;
    case BAND: band_primitive (sp, NULL, &msg);		break;
    case FBS:  first_band_primitive (sp, NULL, &msg);	break;
    default:   error("search: no such strategy\n"); 	break;
  }
  eval_final_approx(sp);
}

