
#ifndef __wise_limits_h_
#define __wise_limits_h_

/** Some UNIX versions support the following limiting numbers:
 **    INT_MAX = 2147483647
 **    LONG_MAX = 2147483647
 **    FLT_MAX	= 3.40282346638528860e+38
 **    DBL_MAX	= 1.7976931348623157e+308		**/

#define		HUGE_INT	(9999999)
#define		HUGE_LONG	(999999999)
#define		HUGE_FLOAT	(1.0e20)
#define		HUGE_DOUBLE	(1.0e50)
#define		HUGE_DEPTH	HUGE_INT

#endif __wise_limits_h_

