
/** LOWB_PLUS_GCOST is defined in  "sort_key"  which is a *function*.  **/

/* insert a node into an ordered list , ascendingly */
void list_insert (node, sp)
  node_ *node;
  search_ *sp;
{ node_ *p, *q;
  domain node_key;

  if (sp->stat.active < 0) sp->stat.active = 0;
  else sp->stat.active++;

  if (sp->open.list) {
    node_key = sort_key(node, sp);
    for (q = p = sp->open.list; p; p = (q = p)->next) {
      if (node_key < sort_key(p, sp)) {
        /** insert **/
        if (p == sp->open.list) (sp->open.list = node)->next = p;
        else (q->next = node)->next = p;
	return;
      }
    }
    if (! p) (q->next = node)->next = NULL;
  }
  else (sp->open.list = node)->next = NULL;
}


/* delete a node from a linked list */
node_ *list_delete (sp)
  search_ *sp;
{ node_ *q = NULL;

  if (sp->open.list) sp->open.list = (q = sp->open.list)->next;
  else { sp->stat.active = 0; return NULL; }
  if (sp->stat.active < 0) sp->stat.active = 0;
  else sp->stat.active--;
  return q;
}


int is_list_empty (sp)
  search_ *sp;
{ return (sp->open.list == NULL); }

