
node_ *root_generator () {
  return allocate_node(NULL, -1);
}

void iipd_init() { }

void idpd_init() { }

int is_dominated (node) node_ *node; { return 0; }


node_ *allocate_node (parentp, entity)
  node_ *parentp;
  int entity;
{ node_ *p;
  int i, j, who;
  domain tmax = (domain) 0.0;

  p = get_search_node_from_pool();
  init_node_struct(p, parentp);

  p->entity = entity;
  p->g_cost = (domain) 0.0;

  /* clean thses value fields */
  p->lowb = - problem.huge;
  p->upb = problem.huge;

  if (parentp)
    for (i = 0; i < nTasks; i++) *(p->sched_time+i) = *(parentp->sched_time+i);
  else
    for (i = 0; i < nTasks; i++) set_task_alive (p, i);

  for (i = 0; i < nTasks; i++)
    if (is_task_alive (p, i)) *(p->open_task+i) = 1;

  if (parentp) {
    for (i = 0; i < nProcessors; i++)
      *(p->proc_ck+i) = *(parentp->proc_ck+i);
  } else {
    for (i = 0; i < nProcessors; i++)
      *(p->proc_ck+i) = (domain) 0.0;
  }

  if (parentp) {
    for (i = 0; i < nResources; i++)
      *(p->resource_ck+i) = *(parentp->resource_ck+i);
  } else {
    for (i = 0; i < nResources; i++)
      *(p->resource_ck+i) = (domain) 0.0;
  }

  if (parentp) {
    tmax = alloc_proc (p->proc_ck, &who); 

    for (j = 0; j < nResources; j++)
      if (REQ[entity][j])
         /** resource j is required **/
         if (tmax < *(p->resource_ck+j)) tmax = *(p->resource_ck+j);

    *(p->sched_time+entity) = tmax;
    tmax += execTime[entity];
    *(p->proc_ck+who) = tmax;

    for (j = 0; j < nResources; j++)
      if (REQ[entity][j]) *(p->resource_ck+j) = tmax;
  }

  tmax = (domain) 0.0;
  for (i = 0; i < nProcessors; i++)
    if (tmax < *(p->proc_ck+i)) tmax = *(p->proc_ck+i);

  p->g_cost = tmax;

  return p;
}


/* allocate associates for newly allocated search nodes */
void pd_region ()
{ int offset, *pool, pck_offset, rck_offset, open_offset, sched_time_offset;
  int *a, i;
  node_ *p;
    
  pool = (int *) pool_manager;
  offset = node_conf.node_size / sizeof(int);
  pck_offset = sizeof(node_) / sizeof(int);
  rck_offset = pck_offset + nProcessors * sizeof (domain) / sizeof (int);
  open_offset = rck_offset + nResources * sizeof (domain) / sizeof (int);
  sched_time_offset = open_offset + nTasks;

  for (i = 0; i < AllocationSize; i++) {
    p = ((node_ *) (a = pool + offset * i));
    p->proc_ck = (domain *) (a + pck_offset);
    p->resource_ck = (domain *) (a + rck_offset);
    p->open_task = (int *) (a + open_offset);
    p->sched_time = (domain *) (a + sched_time_offset);
  }
}


void reset_sol_buf (s)
  solution_ *s;
{ int i;

  for (i = 0; i < problem.size; i++) s->schedTime[i] = (domain) 0.0;
}


void evaluate_solution (sp)
  search_ *sp;
{ solution_ *sol;
  int i, j;

  if (sp) sol = sp->incumbent;
  else error("evaulate_solution: internal error: sp is nil");

  printf ("\nPROBLEM:\n");
  printf ("nTasks=%d, nProcessors=%d, nResources=%d\n",
           nTasks, nProcessors, nResources);

  for (i = 0; i < nTasks; i++)
    printf ("execTime[%d]=%g\n", i, (float) execTime[i]);

  for (i = 0; i < nTasks; i++) {
    for (j = 0; j < nResources; j++)
      printf ("REQ[T=%d][R=%d]=%d, ", i, j, REQ[i][j]);
    printf ("\n");
  }

  printf("\nSOLUTION:\n");
  for (i = 0; i < problem.size; i++)
    printf("%d-th task is scheduled at time  %g\n",
            i, (float) (sol->schedTime[i]));
}

