
#ifndef __PP_config_h_
#define	__PP_config_h_

/* bound.c */
extern solution_ *evaluate_upper_bound();
extern void	evaluate_lower_bound(); 

/* gen.c */
extern void	gen_sample_problem();

/* search.c */
extern int	is_infeasible(), is_feasible();
extern node_	*expand();

/* support.c */
extern int	is_dominated();
extern node_	*root_generator(), *allocate_node();
extern domain	get_problem_domain();
extern void	iipd_init(), idpd_init(), pd_region(), reset_sol_buf(),
		print_conf();

#endif	__PP_config_h_

