
#ifndef __PP_define_h_
#define __PP_define_h_

#define MIN_DELTA_TH	1

typedef int	domain;
#define Domain	INT

#define AllocationSize         256

#define	PDSI_PART	\
	domain	value;		\
	domain	i_value;  	/* i_value is sum of (_x - _r) */ \
	domain	*o_values;	/* ptr to array of child's open values */


#ifndef TEACHER


#define	rParamLow	0	/* requirement */
#define rParamUp	3
#define cParamLow	1	/* capacity */ 
#define cParamUp	4
#define bParamLow	50	/* setup cost */
#define	bParamUp	100
#define pParamLow	10	/* production cost */
#define pParamUp	20
#define hParamLow	5	/* inventory cost */
#define hParamUp	10


#else TEACHER


#ifdef CLASS_1
#define rParamLow       0       /* requirement */
#define rParamUp        3
#define cParamLow       1       /* capacity */
#define cParamUp        4
#define bParamLow       50      /* medium setup cost */
#define bParamUp        100
#define pParamLow       10      /* medium production cost */
#define pParamUp        20
#define hParamLow       5       /* medium inventory cost */
#define hParamUp        10
#endif

#ifdef CLASS_2
#define rParamLow       0       /* requirement */
#define rParamUp        3
#define cParamLow       1       /* capacity */
#define cParamUp        4
#define bParamLow       10      /* low setup cost */
#define bParamUp        20
#define pParamLow       10      /* medium production cost */
#define pParamUp        20
#define hParamLow       5       /* medium inventory cost */
#define hParamUp        10
#endif

#ifdef CLASS_3
#define rParamLow       0       /* requirement */
#define rParamUp        3
#define cParamLow       1       /* capacity */
#define cParamUp        4
#define bParamLow       100     /* high setup cost */
#define bParamUp        200
#define pParamLow       10      /* medium production cost */
#define pParamUp        20
#define hParamLow       5       /* medium inventory cost */
#define hParamUp        10
#endif

#ifdef CLASS_4
#define rParamLow       0       /* requirement */
#define rParamUp        3
#define cParamLow       1       /* capacity */
#define cParamUp        4
#define bParamLow       50      /* medium setup cost */
#define bParamUp        100
#define pParamLow       10      /* medium production cost */
#define pParamUp        20
#define hParamLow       10      /* high inventory cost */
#define hParamUp        20
#endif

#ifdef CLASS_5
#define rParamLow       0       /* requirement */
#define rParamUp        3
#define cParamLow       1       /* capacity */
#define cParamUp        4
#define bParamLow       50      /* medium setup cost */
#define bParamUp        100
#define pParamLow       10      /* medium production cost */
#define pParamUp        20
#define hParamLow       2       /* low inventory cost */
#define hParamUp        5
#endif

#ifdef CLASS_6
#define rParamLow       0       /* requirement */
#define rParamUp        3
#define cParamLow       1       /* capacity */
#define cParamUp        4
#define bParamLow       100     /* high setup cost */
#define bParamUp        200
#define pParamLow       10      /* medium production cost */
#define pParamUp        20
#define hParamLow       10      /* high inventory cost */
#define hParamUp        20
#endif

#ifdef CLASS_7
#define rParamLow       0       /* requirement */
#define rParamUp        3
#define cParamLow       1       /* capacity */
#define cParamUp        4
#define bParamLow       100     /* high setup cost */
#define bParamUp        200
#define pParamLow       10      /* medium production cost */
#define pParamUp        20
#define hParamLow       2       /* low inventory cost */
#define hParamUp        5
#endif

#ifdef CLASS_8
#define rParamLow       0       /* requirement */
#define rParamUp        3
#define cParamLow       1       /* capacity */
#define cParamUp        4
#define bParamLow       10      /* low setup cost */
#define bParamUp        20
#define pParamLow       10      /* medium production cost */
#define pParamUp        20
#define hParamLow       10      /* high inventory cost */
#define hParamUp        20
#endif

#ifdef CLASS_9
#define rParamLow       0       /* requirement */
#define rParamUp        3
#define cParamLow       1       /* capacity */
#define cParamUp        4
#define bParamLow       10      /* low setup cost */
#define bParamUp        20
#define pParamLow       10      /* medium production cost */
#define pParamUp        20
#define hParamLow       2      /* low inventory cost */
#define hParamUp        5
#endif


#endif TEACHER


#define ProductionRange	(cParamUp + 2)
#define	MaxProblemSize	30

typedef struct
{
	domain	prod[MaxProblemSize];
} solution_;

#endif __PP_define_h_

