
void gen_sample_problem ()
{ domain sum_r = 0, sum_c = 0;
  domain increase, small, temp;
  int i, j;

  for (i = 1; i <= problem.size; i++) {
    sum_r += (rParam[i] = gen_random_int(rParamLow, rParamUp));
    bParam[i] = gen_random_int(bParamLow, bParamUp);
    hParam[i] = gen_random_int(hParamLow, hParamUp);
    sum_c += (cParam[i] = gen_random_int(cParamLow, cParamUp));
    pParam[i] = gen_random_int(pParamLow, pParamUp);
    while (sum_r > sum_c) {
      increase = gen_random_int(cParamLow, (cParamUp + cParamLow) / 2);
      cParam[i] += increase;
      sum_c += increase;
    }
  }

  /* create pSort[] according the ascending order in pParam[]
   * pSort[i] = entity   means  entity has the i-th smallest pParam value.
   */
  /* reset _q */
  for (i = 1; i <= problem.size; i++) pSort[i] = i;

  /* bubble sort ascedingly */
  for (i = 1; i < problem.size; i++) {
    small = i;
    for (j = i + 1; j <= problem.size; j++)
      if (pParam[pSort[small]] > pParam[pSort[j]]) small = j;
      temp = pSort[i]; pSort[i] = pSort[small]; pSort[small] = temp;
  }

  set_node_size(ProductionRange * sizeof(domain));

#ifdef DEBUG
if (cmd.debug >= 2) print_conf(stdout);
#endif
}

