#ifndef	__PUZZ_define_h_
#define	__PUZZ_define_h_

/** this compiler definition is essential, please don't delete it **/
#define DELAY_FREE_NODE

#define MIN_DELTA_TH	2

#define LPG_LARGE_CONST		1000	/** usually opt val is less than 100 **/

typedef	long	domain;
#define Domain	LONG

#define AllocationSize         256

#define	PDSI_PART	\
	int	*locmap;	/** location map of tiles **/

/** for problem generation **/
#define	MaxProblemSize	30

#define	NOT_USED_DIR	('?')

/** solution is a pointer to node_ structure, however, it is not declared yet,
 ** as a result, "void *" is used instead. **/
typedef struct { int pre_buf; char *move; int post_buf; } solution_;

/** shorthand **/
#define	get_x(loc)	(loc % LayoutSize1)
#define	get_y(loc)	((int) (loc / LayoutSize1))
#define get_loc(x,y)	(x + y * LayoutSize1)

#endif	__PUZZ_define_h_

