#ifndef	__RCS_define_h_
#define	__RCS_define_h_

#define MIN_DELTA_TH	1

typedef	int	domain;
#define Domain	INT

#define	MaxProblemSize	160
#define AllocationSize	256

#define	PDSI_PART	\
	int	value;		/* assigned to which processor */  \
	int	round;		/* # roundups, usually 0 or 1 */   \
	int	*rb;		/* resource bound pointer */       \
	int	*proc;		/* processor status pointer */     \
	int	*open_task;	/* open pointer, to be selected */ \
	int	*live_task;	/* live pointer, not selected */


typedef struct
{
	int	sched[MaxProblemSize];
} solution_;


#define	_R_Low		10		/* resource requirements */
#define _R_Up		20
#define _B_Low		40		/* capacity bound */
#define	_B_Up		60
#define _n_R_Low	3		/* num of resources */
#define _n_R_Up		3
#define _n_P_Low	3		/* num of processors */
#define _n_P_Up		3

#define MaxResource	(_n_R_Up + 2)
#define MaxProcessor	(_n_P_Up + 2)

#endif	__RCS_define_h_

