
void gen_sample_problem()
{ int t, i;

  /* generate the numbers of resources randomly */
  T = problem.size;
  R = gen_random_int(_n_R_Low, _n_R_Up);
  M = gen_random_int(_n_P_Low, _n_P_Up);

  /* generate the problem parameters randomly */
  for (i = 0; i < R; i++) BOUND[i] = gen_random_int(_B_Low, _B_Up);
  for (t = 0; t < T; t++) 
    for (i = 0; i < R; i++)
      while ((REQ[t][i] = gen_random_int(_R_Low, _R_Up)) > BOUND[i]) ;

#ifdef DEBUG
if (cmd.debug >= 2) {
  printf("T(# tasks)=%d, R(# resources)=%d, M(# processors)=%d\n", T, R, M);
  for (i = 0; i < R; i++) printf("BOUND[%d]=%d, ", i, BOUND[i]);
  printf("\n");
  for (t = 0; t < T; t++) {
    printf("TASK #%d:\n", t);
    for (i = 0; i < R; i++) printf("REQ[%d][%d]=%d, ", t, i, REQ[t][i]);
    printf("\n");
  }
}
#endif

  set_node_size((R + M + T + T) * sizeof(int));
}

