#ifndef	__ATS_define_h_
#define	__ATS_define_h_

#ifndef SYM_TSP
#ifndef ASYM_TSP
#define ASYM_TSP
#endif
#endif

#define MIN_DELTA_TH	1

typedef	float	domain;
#define Domain	FLOAT

#define AllocationSize         256

#define	PDSI_PART	\
	int	*open;	  /* open cities, same as *live if this node is new, \
			     and it's different from *live if compound node. \
			     (not considered yet) */ \
	int	nvisit;   /* num of cities visited already */ \
	int	*visited; /* visited cities */


/* for problem generation */
#define	MaxProblemSize	200
#define MaxLinkSize	(MaxProblemSize * MaxProblemSize)

/* geographical limit of graph */
#define	GeoLimit		100

typedef struct
{
	int	city[MaxProblemSize];
} solution_;

#define encodeW(x,y)	(x * nCities + y)
#define decodeW(road)	*(WEIGHT + road)
#define	Weight(x,y)	*(WEIGHT + encodeW(x,y))
#define sortW(index)	*(SORTW + index)
#define decodeX(road)	((int) (road / nCities))
#define decodeY(road)	(road % nCities)

#endif	__ATS_define_h_

