
void gen_sample_problem()
{ int i, j;

  /* generate the numbers of resources randomly */
  nTasks = problem.size;
  nProcessors = gen_random_int (_n_P_Low, _n_P_Up);
  nResources = gen_random_int (_n_R_Low, _n_R_Up);

  nProcessors = 2;
  nResources = 4;

  /* gen tasks' exec times randomly */
#ifdef SIMPLE_RCS
  for (i = 0; i < nTasks; i++) execTime[i] = 1.0;
#else
  for (i = 0; i < nTasks; i++) execTime[i] = gen_random_range (_T_Low, _T_Up);
#endif

  /** gen tasks' resources' requirements **/
  for (i = 0; i < nTasks; i++)
    for (j = 0; j < nResources; j++)
      REQ[i][j] = (gen_random_float () <= 0.5) ? 1 : 0;

  set_node_size ((nProcessors + nResources + nTasks) * sizeof (float) +
                  nTasks * sizeof (int));
}

