
#ifndef __MAZE_config_h_
#define	__MAZE_config_h_

/* bound.c */
extern solution_	*evaluate_upper_bound ();
extern void		evaluate_lower_bound ();
extern int		calc_goal_distance ();

/* gen.c */
extern void	gen_sample_problem (), gen_sample_problem (), init_maze ();
extern void	enhance_maze (), print_maze ();
extern directn	rand_door ();
extern int	backtrack ();


/* search.c */
extern int	decomposition (), is_infeasible (), is_feasible ();
extern node_	*expand (), *get_child ();
extern yesno_	is_movable ();

/* support.c */
extern int	is_dominated ();
extern node_	*root_generator (), *allocate_node ();
extern domain	get_problem_domain ();
extern void	iipd_init (), idpd_init (), pd_region (), reset_sol_buf (),
		evaluate_solution ();

#endif	__MAZE_config_h_

