
node_ *root_generator ()
{ node_ *root;

  /* generate a root node */
  root = allocate_node(NULL, 0, 0, 0, 0);
  gen_open_value(root);
  return root;
}

void iipd_init () {}
void idpd_init () {}


node_ *allocate_node (parentp, entity, value, i_value, g_cost)
  node_ *parentp;
  int entity;
  domain value, i_value, g_cost;
{ node_ *p;

  p = get_search_node_from_pool();
  init_node_struct(p, parentp);

  p->entity = entity;
  p->g_cost = g_cost;
  p->value = value;
  p->i_value = i_value;

  /* clean up these value fields */
  p->lowb = - problem.huge;
  p->upb = problem.huge;

  return p;
}


void reset_sol_buf (s)
  solution_ *s;
{ int i;

  for (i = 0; i < problem.size; i++) s->prod[i] = 0;
}


void print_conf (fp)
  FILE *fp;
{ int i;

  for (i = 1; i <= problem.size; i++) {
    fprintf(fp, "x[%d]=%d, r[%d]=%d, c[%d]=%d, p[%d]=%d, ",
                 i, xParam[i], i, rParam[i], i, cParam[i], i, pParam[i]);
    fprintf(fp, "h[%d]=%d, b[%d]=%d\n", i, hParam[i], i, bParam[i]);
  }
}


void evaluate_solution (sp)
  search_ *sp;
{ solution_ *sol;
  int i;

  if (sp) sol = sp->incumbent;
  else error("evaulate_solution: internal error: sp is nil");
  printf("\nSOLUTION:\n");
  for (i = 0; i < problem.size; i++)
    printf("%d-th production is  %d\n", i, sol->prod[i]);
}


/* allocate associates for newly allocated search nodes */
void pd_region()
{ int offset, *pool, o_val_offset, *a, i;
  node_ *p;
    
  pool = (int *) pool_manager;
  offset = node_conf.node_size / sizeof(int);
  o_val_offset = sizeof(node_) / sizeof(int);

  for(i = 0; i < AllocationSize; i++) {
    p = ((node_ *) (a = pool + offset * i));
    p->o_values = a + o_val_offset;	/* allocate *o_values frame */ 
  }
}

