
node_ *root_generator () { return (allocate_node (NULL, -1, (domain) 0)); }

void iipd_init ()
{ _tilemap = (int *) malloc (problem.size * problem.size * sizeof (int)); }

void idpd_init () { }

int is_dominated (node) node_ *node; { return 0; }


node_ *allocate_node (parentp, entity, g_cost)
    node_ *parentp;
    int entity;
    domain g_cost;
{   node_ *p;
    int i;

    p = get_search_node_from_pool();
    init_node_struct(p, parentp);

    p->entity = entity;
    p->g_cost = g_cost;

    /** clean thses value fields **/
    p->lowb = - problem.huge;
    p->upb = problem.huge;

    if (parentp) {
	for (i = 0; i < LayoutSize2; i++)
	    *(p->locmap + i) = *(parentp->locmap + i);
	move_blank (p, entity);
    } else {
	for (i = 0; i < LayoutSize2; i++)
	    *(p->locmap + i) = *(InitLocMap + i);
    }

    return p;
}


/** allocate associates for newly allocated search nodes **/
void pd_region ()
{   int offset, *pool, locmap_offset, *a, i;
    node_ *p;
    
    pool = (int *) pool_manager;
    offset = node_conf.node_size / sizeof (int);
    locmap_offset = sizeof (node_) / sizeof (int);
    for (i = 0; i < AllocationSize; i++) {
	p = ((node_ *) (a = pool + offset * i));
	p->locmap = a + locmap_offset;	/** allocate *locmap frame **/ 
    }
}


void reset_sol_buf (s) solution_ *s; { s->move = NULL; }


void print_conf (locmap)
    int locmap[];
{   int x, y, loc, tile;
 
    /** transform locmap into tilemap **/
    for (tile = 0; tile < LayoutSize2; tile++)
	*(_tilemap + locmap[tile]) = tile;

    /** print out the board based on tilemap **/
    printf ("\n");
    for (y = LayoutSize1 - 1; y >= 0; y--) {
	for (x = 0; x < LayoutSize1; x++) {
	    loc = get_loc (x, y);
	    printf (" %2d  ", *(_tilemap + loc));
	}
	printf ("\n");
    }
}


void evaluate_solution (sp)
    search_ *sp;
{   solution_ *sol;
    int i;

    if (sp) sol = sp->incumbent;
    else error ("evaluate_solution: internal error: sp is nil");

    printf ("\nInitial Board");
    print_conf (InitLocMap);
    printf ("Goal Board");
    print_conf (GoalLocMap);
    printf ("\nSOLUTION:\n");

    for (i = 0; *(sol->move+i) != NOT_USED_DIR; i++) {
#ifdef FULL_DISPLAY
	printf ("\n%c", (char) *(sol->move+i));
	move_locmap_blank (InitLocMap, (int) *(sol->move+i));
	print_conf (InitLocMap);
#else
	printf (" %c ", (char) *(sol->move+i));
#endif
    }
    printf ("\n");
}

