
#ifndef __RCS_config_h_
#define	__RCS_config_h_

/* bound.c */
extern int	pre_solution();
extern domain	_eval_lowb(), _eval_upb();
extern solution_	*evaluate_upper_bound();
extern void	evaluate_lower_bound(), update_bounds();

/* gen.c */
extern void	gen_sample_problem();

/* search.c */
extern int	decomposition(), is_infeasible(), is_feasible(), alloc_resource(),
		satisfy_constr();
extern float	h_fun(), _h_fun();
extern node_	*expand(), *get_left_child(), *get_right_child();
extern void	another_round();

/* support.c */
extern int	is_dominated();
extern node_	*root_generator(), *allocate_node(), *sprout_child();
extern domain	get_problem_domain();
extern void	iipd_init(), idpd_init(), pd_region(), reset_sol_buf(),
		print_conf();

#endif	__RCS_config_h_

