
void gen_sample_problem ()
{   int i, j;
    FILE *fp, *fopen ();

    NumVertices = problem.size;
    NumEdges = 0;

    /** clean up problem attributes **/
    for (i = 0; i < NumVertices; i++)
	for (j = 0; j < NumVertices; j++)
	    Adjacency[i][j] = VC_DEAD;

    /** randomly generate connectivity (0.1, 0.2) **/
    /** Threshold = 3.0 / problem.size; **/

#ifndef TEACHER


    Threshold = 0.1;


#else TEACHER


#ifdef CLASS_1
    Threshold = 0.10;
#endif

#ifdef CLASS_2
    Threshold = 0.05;
#endif

#ifdef CLASS_3
    Threshold = 0.15;
#endif

#ifdef CLASS_4
    Threshold = 0.20;
#endif

#ifdef CLASS_5
    Threshold = 0.25;
#endif

#ifdef CLASS_6
    Threshold = 0.30;
#endif

#ifdef CLASS_7
    Threshold = 0.35;
#endif


#endif

    /** randomly generate edges according to Threshold **/
    for (i = 0; i < NumVertices-1; i++)
	for (j = i; j < NumVertices; j++)
	    if (i != j)
		if (gen_random_float () <= Threshold) {
		    Adjacency[i][j] = Adjacency[j][i] = NumEdges;
		    Edges[NumEdges].x = i;
		    Edges[NumEdges].y = j;
		    NumEdges++;
		}

  set_node_size (NumVertices * sizeof (int));

#ifdef VC_LAYOUT
  fp = fopen (".vc", "a");
  fprintf (fp, "VC(%d,%d,%d)\n", problem.size, NumEdges, problem.seed);
  fclose (fp);
#endif

}

