#ifndef __VC_output_h_
#define __VC_output_h_

/*
	Output Format Control Signals
	Every control signals must be defined to be either 1 or 0.
*/

#define		OUT_GRAPH		1
#define		OUT_SUMMARY		1

#define		OUT_TIME_LIMIT		1
#define		OUT_SPACE_LIMIT		0
#define		OUT_CST_LIMIT		0

#define		OUT_REAL_TIME		0
#define		OUT_REAL_MAX_SPACE	0
#define		OUT_REAL_CST		0

#define		OUT_VIRTUAL_TIME	1
#define		OUT_VIRTUAL_MAX_SPACE	1
#define		OUT_VIRTUAL_CST		1

#define		OUT_ROOT_APPROX		1
#define		OUT_RUN_TIME_APPROX	1
#define		OUT_APPROX		1

#define		OUT_INCUMBENT		1
#define		OUT_LOWB		1
#define		OUT_THRESHOLD		1

/*	sTCA & sTCGD & pTCGD		*/
#define		OUT_GRADIENT_FACTOR	1

/*	pTCA & dTCA & pTCGD 	*/
#define		OUT_STOPPING_FACTOR	1
#define		OUT_CORRECTIVE_FACTOR	1

#endif __VC_output_h_

