
void gen_sample_problem()
{ int i, j, best_one, temp;
  float max_ratio = 0.0;

  /* generate the numbers of resources randomly */
  nTasks = problem.size;
  nProcessors = 3;

  /** find out the sort version of tasks **/
  for (i = 0; i < nTasks; i++) {
    sortTask[i] = i;
    execTime[i] = gen_random_range (_T_Low, _T_Up);
    WdivT[i] = gen_random_range (0.9, 1.1);
    Weight[i] = WdivT[i] * execTime[i];
  }
  for (i = 0; i < nTasks; i++) {
    best_one = i;
    max_ratio = WdivT[sortTask[best_one]];
    for (j = i+1; j < nTasks; j++)
      if (WdivT[sortTask[j]] > max_ratio) {
        best_one = j;
        max_ratio = WdivT[sortTask[j]];
      }
    temp = sortTask[i];
    sortTask[i] = sortTask[best_one];
    sortTask[best_one] = temp;
  }

  set_node_size ((nProcessors + nTasks) * sizeof (float) +
                  nTasks * sizeof (int));
}

